<template>
  <div>
    <q-spinner-gears
        v-if="!message.length && !messageEmpty"
        color="primary"
        size="8em"
        class="mx-auto mt-12"
    />
    <div v-if="messageEmpty">
      <q-card>
        <p class="text-xl text-center py-8 mb-8">Тут пусто!</p>
      </q-card>
      <q-btn @click="addMessage" label="Добавить" icon-right="add" color="green" class="mx-auto block"/>
    </div>
    <div v-else-if="message.length && !messageEmpty">
      <q-btn @click="addMessage" label="Добавить" icon-right="add" color="green" class="mx-auto block my-8"/>
      <q-expansion-item v-for="(item, i) in message" :key="item._id">
        <template v-slot:header>
          <p class="flex items-center text-center px-2 py-1 rounded" :style="{backgroundColor: item.color, color: '#ffffff'}">
            {{item.name}}
          </p>
          <q-space/>
        </template>
        <div class="px-4 sm:px-8 grid grid-cols-8 w-full">
          <div class="col-span-5 grid grid-rows-7">
            <q-input @change="changeMessage(item)" class="row-span-2" :model-value="item.name" v-model="item.name" label="Название шаблона" />
            <q-input @change="changeMessage(item)" class="row-span-5" type="textarea" :model-value="item.sms" v-model="item.sms" label="Текст сообщения" />
          </div>
          <div class="col-span-3 grid grid-rows-7 items-center justify-center">
            <q-toggle v-model="item.visible" @click="changeMessage(item)" :model-value="item.visible" label="Показывать" class="row-span-1" />
            <q-btn icon="palette" label="Цвет">
              <q-menu auto-close>
                <q-color v-model="item.color"
                         :model-value="item.color"
                         no-header
                         no-footer
                         default-view="palette"
                         class="my-picker w-20 row-span-3"
                         @change="changeMessage(item)"
                />
              </q-menu>
            </q-btn>
            <q-btn icon="delete" label="Удалить" color="red" @click="deleteMessage(item._id, i)" class="row-span-3"/>
          </div>
        </div>
      </q-expansion-item>
    </div>
  </div>
</template>

<script>
import {ref} from "vue";
import api from "../../API/api";

export default {
  name: "Temp-Message-settings",
  setup () {
    const message = ref([])
    const messageEmpty = ref(false)
    api.getTemplateSMS()
      .then(r => {
        message.value = r.data.template
        if (!message.value.length) messageEmpty.value = true
      })
    async function addMessage () {
      const item = {
        name: 'Новый шаблон',
        sms: 'Это новый шаблон сообщения',
        color: '#696969',
        visible: true
      }
      await api.addTemplateSMS(item)
        .then((r) => {
          item._id = r.data._id
          message.value.unshift(item)
          messageEmpty.value = false
        })
    }
    async function changeMessage (item) {
      await api.changeTemplateSMS(item)
    }
    async function deleteMessage (_id, index) {
      await api.deleteTemplateSMS({_id})
        .then(() => {
          message.value.splice(index, 1)
          if (!message.value.length) messageEmpty.value = true
        })
    }
    return {
      message,
      messageEmpty,
      addMessage,
      changeMessage,
      deleteMessage,
    }
  }
}
</script>

<style scoped>

</style>